
colBoxes = {}

--[[function colBox:addAt(x, y, blob)  -- Useful?
  if not colBox[y][x] then
    colBox[y][x] = {blob} -- Create new table at (x, y)
  else
    colBox[y][x][#colBox[y][x] + 1] = blob -- Last element of the table at (x, y)
  end
end]]
--

local size = 8 -- the length of the side of the box, in number of blobs

function colBoxes.add(blob)
    local blobX, blobY = blob:getPosition()
    local x, y = math.floor(blobX/size), math.floor(blobY/size)
    
    if not colBoxes[y] then
      colBoxes[y] = {}
      colBoxes[y][x] = {}
      colBoxes[y][x].blobs = {blob}
      colBoxes[y][x].revBlobs = {blob = 1}
    --[[elseif not colBoxes[y][x] then
      colBoxes[y][x] = {}
      colBoxes[y][x].blobs = {blob}
      colBoxes[y][x].revBlobs = {blob = 1}
    elseif not colBoxes.blob then
      colBoxes[y][x].blobs = {blob}
      colBoxes[y][x].revBlobs = {blob = 1}]]
    else
      colBoxes[y][x].blobs[#colBoxes[y][x].blobs + 1] = blob
      colBoxes[y][x].revBlobs[blob] = #colBoxes[y][x].blobs
      
      --colBoxes[y][x][#colBoxes[y][x] + 1] = blob
      --colBoxes[y][x]{blobs = {}, revBlobs = {}}
    end
end

function colBoxes.remove(blob)
  local blobX, blobY = blob:getPosition()
  local x, y = math.floor(blobX/size), math.floor(blobY/size)
  
  --local blobs = colBoxes[y][x].blobs
  --local revBlobs = colBoxes[y][x].revBlobs
  
  local blobI = colBoxes[y][x].revBlobs[blob]
  local length = #colBoxes[y][x].blobs - 1   -- number of blobs, before removal
  
  if (length - 1) <= 0 then -- no more blobs, destroy box
    colBoxes[y] = nil
  else
    colBoxes[y][x].revBlobs[blob] = nil
    colBoxes[y][x].blobs[blobI] = nil   -- Use reverse table to remove the specific blob
    
    local lastBlob = colBoxes[y][x].blobs[length]
    
    colBoxes[y][x].revBlobs[lastBlob] = blobI
    colBoxes[y][x].blobs[blobI] = lastBlob
    
    colBoxes[y][x].blobs[length] = nil
  end
  
  --colBoxes[y][x].blobs = blobs
  --colBoxes[y][x].revBlobs = revBlobs
  
  --colBoxes[y][x]
end

function colBoxes.check(blob)
  local lastX, lastY = blob:getColBox()
  
  local blobX, blobY = blob:getPosition()
  local curX, curY = math.floor(blobX/size), math.floor(blobY/size)
  
  if curX == lastX or curY == lastY then
    return true
  else
    colBoxes.add(blob)
    colBoxes.remove(blob)
    blob:setColBox(curX, curY)
    
    return true
  end
end
